/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.PekerjaanDto;
import com.portofolio.service.PekerjaanService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/pekerjaan")
public class PekerjaanController extends LocaleController {
    @Lazy
	@Autowired
    private PekerjaanService pekerjaanService;
    
    
    @ApiOperation("Api Untuk Menyimpan Pekerjaan")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PekerjaanDto entity,HttpServletRequest request) {
        Map<String, Object> result = pekerjaanService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Pekerjaan")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdPekerjaan", required = true) Integer kdPekerjaan,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody PekerjaanDto entity, HttpServletRequest request) {
        Map<String, Object> result = pekerjaanService.update(entity,kdPekerjaan,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Pekerjaan Berdasarkan KdPekerjaan")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdPekerjaan", required = true) Integer kdPekerjaan,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = pekerjaanService.deleteById(kdPekerjaan, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Pekerjaan")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaPekerjaan") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaPekerjaan", required = false) String namaPekerjaan,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = pekerjaanService.grid(page, rows, sort, dir, namaPekerjaan,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Pekerjaan Berdasarkan kdPekerjaan")
    @GetMapping("/findByKdPekerjaan")
    public ResponseEntity<Map<String, Object>> findByKdPekerjaan(
    		@RequestParam(value = "kdPekerjaan", required = true) Integer kdPekerjaan, 
    		HttpServletRequest request) {
        Map<String, Object> result = pekerjaanService.findByKdPekerjaan(kdPekerjaan);
        return RestUtil.getJsonResponse(result);
    }


}
